#!/usr/bin/env python
# -*- coding: UTF8 -*-
# Created by Ratur

# Python module kiba_icons.py
# Autogenerated from kiba-icons.glade
# Generated on Sun Aug 27 12:15:11 2006

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

import os, sys, time

import gconf
import gtk
import gnome

from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

app_name = "kiba-icon-editor"
app_version = "0.0.999"

glade_dir = ""
locale_dir = ""

bindtextdomain(app_name, locale_dir)

#-------------------------
def extract2(liste, x, y):
#-------------------------
    """ Extract informations from a file """
    nameVar=""
    for i in liste:
        if i.startswith(x):
            liste2 = list(i)[y:]
            nameVar = "".join(liste2)
            break
    return nameVar

#-----------------------------
def get_active_text(combobox):
#-----------------------------
    """ Get active text from a combobox """
    model = combobox.get_model()
    active = combobox.get_active()
    if active < 0:
        return None
    return model[active][0]

#-----------------------------
def kibaRestart(prefix,kpath):
#-----------------------------
    """ Restart kiba-dock """
    kibaExec = "kiba-dock &"
    os.system("killall %s" %kibaExec)
    #if os.path.exists("/usr/bin/%s &" %kibaExec):
    os.system(kibaExec)
    #else :
        #os.system("exec %s/%s &" %(prefix, kibaExec))

#--------------------------
def openIconDialog(folder):
#--------------------------
    """ Create a dialog for icon opening """
    dialog = gtk.FileChooserDialog("Open..", None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK))
    dialog.set_current_folder(folder)
    dialog.add_shortcut_folder(folder+"/.icons")
    dialog.set_default_response(gtk.RESPONSE_OK)
    filter = gtk.FileFilter()
    # Adds some interesting filters
    filter.set_name("Images")
    filter.add_mime_type("image/png")
    filter.add_mime_type("image/jpeg")
    filter.add_mime_type("image/gif")
    filter.add_pattern("*.png")
    filter.add_pattern("*.jpg")
    filter.add_pattern("*.gif")
    filter.add_pattern("*.tif")
    filter.add_pattern("*.xpm")
    filter.add_pattern("*.svg")
    dialog.add_filter(filter)
    filter = gtk.FileFilter()
    filter.set_name("All files")
    filter.add_pattern("*")
    dialog.add_filter(filter)
    response = dialog.run()
    if response == gtk.RESPONSE_OK:
        rep = dialog.get_filename()
    elif response == gtk.RESPONSE_CANCEL:
        rep = ""
    dialog.destroy()
    return rep

#--------------------------
def openDeskDialog(folder):
#--------------------------
    """ Create a dialog for .desktop file opening """
    dialog = gtk.FileChooserDialog("Open..", None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK))
    dialog.set_current_folder(folder)
    dialog.set_default_response(gtk.RESPONSE_OK)
    filter = gtk.FileFilter()
    filter.set_name("Images")
    filter.add_pattern("*.desktop")
    dialog.add_filter(filter)
    filter = gtk.FileFilter()
    filter.set_name("All files")
    filter.add_pattern("*")
    dialog.add_filter(filter)
    response = dialog.run()
    if response == gtk.RESPONSE_OK:
        rep = dialog.get_filename()
    elif response == gtk.RESPONSE_CANCEL:
        rep = ""
    dialog.destroy()
    return rep

#--------------------
def listePositions():
#--------------------
    """ Create a list with each launcher position """
    client = gconf.client_get_default()
    liste1 = client.all_dirs("/apps/kiba/launchers")
    #print liste1
    liste3 = [""]*len(liste1)
    for i in liste1 :
        j = os.path.basename(i)
        pos = client.get_int("/apps/kiba/launchers/%s/position" %j)
        #print pos
        try :
            liste3[pos-1] = j
        except :
            liste3.append(j)
    #print liste3
    while True :
        try :
            liste3.remove("")
        except :
            break
    return liste3

#-----------------------------
class Window1(SimpleGladeApp):
#-----------------------------

    def __init__(self, path="kiba-icons.glade", root="window1", domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- Window1.new {
    #-------------
    def new(self):
    #-------------
        """ Variables init """
        # main window
        self.name = ""
        self.namelow = ""
        self.icon = ""
        self.fileName = ""
        self.cmd = ""
        self.homedir = os.environ['HOME']
        self.prefix = os.path.dirname(os.path.abspath(sys.argv[0]))
        self.dire = os.path.expanduser("~/.kiba-dock")      # Default .kiba-dock directory
        self.icondir = ""                                   # Default icons folder
        self.entry1.set_text(self.dire)
        self.entry2.set_text(self.icondir)
        self.listMain = os.listdir(self.dire)                  # list of .desktop files
        self.newItem = True
        #print self.listMain
        try :
            self.listMain.remove('profiles')
        except :
            pass
        for i in self.listMain :
            if i.endswith('.desktop') :
                pass
            else :
                self.listMain.remove(i)
        self.listMain.sort()
        for i in self.listMain :
            self.combobox1.append_text(i)
        #print self.listMain
        self.listPos = listePositions()
        self.client = gconf.client_get_default()
        self.ajuste = self.spinbutton1.get_adjustment()
        self.listNew = []
        try :
            self.arg = sys.argv[1]
            #print self.arg
        except : 
            self.arg = ""
        if self.arg != "":
            filea = os.path.split(self.arg)[1]
            self.opening_file((filea))
            self.combobox1.set_active(self.listMain.index(self.arg))
            self.statusbar.push(1, "%s file selected" %self.fileName)
    #-- Window1.new }



    #-- Window1 custom methods {
    #-----------------------------
    def opening_file(self, *args):
    #-----------------------------
        """ Open a .desktop file from the combobox """
        try :
            self.fileName = args[0]
            #self.lecture = file(self.dire + "/" + self.fileName, "r")
            self.namelow = os.path.splitext(self.fileName)[0]
        except :
            pass
        self.gconfdir = "/apps/kiba/launchers/%s" %self.namelow
        self.name = self.client.get_string(self.gconfdir + "/name")
        self.cmd = self.client.get_string(self.gconfdir + "/exec")
        self.icon = self.client.get_string(self.gconfdir + "/icon")
        self.entry3.set_text(self.name)
        self.entry4.set_text(self.cmd)
        self.entry5.set_text(self.icon)
        if os.path.isabs(self.icon):
            self.image6.set_from_file(self.icon)
        else :
            self.icon = os.path.splitext(self.icon)[0]
            self.image6.set_from_icon_name(self.icon, 3)
        self.spinbutton1.set_value(self.listPos.index(self.namelow) +1)
        self.newItem = False

    #--------------
    def clean(self):
    #--------------
        """ Clean all text entries """
        self.entry3.set_text("")
        self.entry4.set_text("")
        self.entry5.set_text("")
        self.name, self.cmd, self.icon, self.fileName, self.namelow = "", "", "", "", ""
        self.image6.clear()
    #-- Window1 custom methods }



    #-- Window1.on_buttonVal1_clicked {
    #----------------------------------------------
    def on_buttonVal1_clicked(self, widget, *args):
    #----------------------------------------------
        """ When button "Apply settings" is pressed """
        # selecting working dir
        self.dire = os.path.abspath(self.entry1.get_text())
        for i in range(len(self.listMain)):
            self.combobox1.remove_text(0)
        list2 = os.listdir(self.dire)
        self.listMain = []
        for i in list2 :
            if i.endswith(".desktop"):
                self.listMain.append(i)
        self.listMain.sort()
        self.statusbar.push(3, "Kiba personnal directory changed to %s" %self.dire)
        for i in self.listMain :
            self.combobox1.append_text(i)
    #-- Window1.on_buttonVal1_clicked }

    #-- Window1.on_buttonImport_clicked {
    #------------------------------------------------
    def on_buttonImport_clicked(self, widget, *args):
    #------------------------------------------------
        """ When button "import file" is pressed """
        self.fileComp = openDeskDialog(self.homedir)
        #print self.fileComp
        if self.fileComp == "" :
            return
        self.lecture = file(self.fileComp, "r")
        self.lectList = self.lecture.read().split("\n")
        self.lecture.close()
        self.name = extract2(self.lectList, "Name", 5)
        self.cmd = extract2(self.lectList, "Exec", 5)
        self.icon = extract2(self.lectList, "Icon", 5)
        self.namelow = self.name.lower().replace(" ","")
        self.fileNew = self.namelow + ".desktop"
        self.spinbutton1.set_value(len(self.listPos))
        #print self.fileNew
        self.ext = os.path.splitext(self.icon)[1]
        if self.icondir != "" :
            os.system("cp %s %s/%s%s" %(self.icon, self.icondir, self.namelow, self.ext))
            self.icon = "%s/%s%s" %(self.icondir, self.namelow, self.ext)
        self.ecriture = file(self.dire +"/"+self.fileNew, 'w')
        self.ecriture.write("[Desktop Entry]\n")
        self.ecriture.write("Version=1.0\n")
        self.ecriture.write("Encoding=UTF-8\n")
        self.ecriture.write("Name=%s\n" %(self.name))
        self.ecriture.write("Comment=vide\n")
        self.ecriture.write("Exec=%s\n" %(self.cmd))
        self.ecriture.write("Icon=%s\n" %(self.icon))
        self.ecriture.write("Terminal=false\n")
        self.ecriture.write("Type=Application\n")
        self.ecriture.write("Categories=Application;\n")
        self.ecriture.close()
        self.entry3.set_text(self.name)
        self.entry4.set_text(self.cmd)
        self.entry5.set_text(self.icon)
        if os.path.isabs(self.icon):
            self.image6.set_from_file(self.icon)
        else :
            self.icon = os.path.splitext(self.icon)[0]
            self.image6.set_from_icon_name(self.icon,3)
        if not (self.fileNew in self.listMain) :
        # Add launcher into combobox
            self.combobox1.append_text(self.fileName)
            self.listMain.append(self.fileName)
            self.listNew.append(self.namelow)
            self.listPos.append(self.namelow)
            self.spinbutton1.set_value(len(self.listPos))
        self.statusbar.push(9, "Launcher successfully imported : %s" %self.fileNew)
    #-- Window1.on_buttonImport_clicked }

    #-- Window1.on_combobox1_changed {
    #---------------------------------------------
    def on_combobox1_changed(self, widget, *args):
    #---------------------------------------------
        """ When selecting a entry in combobox """
        # Opening .desktop file process
        self.nombre = self.combobox1.get_active()
        self.fileName = self.listMain[self.nombre]
        self.namelow = os.path.splitext(self.fileName)[0]
        #print self.namelow
        self.opening_file()
        self.statusbar.push(1, "%s file selected" %self.fileName)
        self.newItem = False
    #-- Window1.on_combobox1_changed }

    #-- Window1.on_buttonNew_clicked {
    #---------------------------------------------
    def on_buttonNew_clicked(self, widget, *args):
    #---------------------------------------------
        """ Clean all entries """
        self.clean()
        self.spinbutton1.set_value(len(self.listPos) +1)
        self.statusbar.push(1, "New launcher : please fill in all entries")
        self.newItem = True
    #-- Window1.on_buttonNew_clicked }

    #-- Window1.on_buttonDel_clicked {
    #---------------------------------------------
    def on_buttonDel_clicked(self, widget, *args):
    #---------------------------------------------
        """ When "delete" button is pressed """
        # Delete a .desktop file
        if self.fileName == "":
            self.nombre = self.combobox1.get_active()
            self.namelow = self.fileName.split(".")[0]
        #print self.namelow
        self.key = "/apps/kiba/launchers/"+self.namelow
        os.system("gconftool-2 --recursive-unset "+self.key)
        self.listPos.remove(self.namelow)
        self.listMain.remove(self.fileName)
        #self.combobox1.set_active(-1)
        self.combobox1.remove_text(self.nombre)
        self.x = self.dire+"/" + self.fileName
        if os.path.dirname(self.x) == self.dire :
            print "removing file"
            os.system("rm -rf %s" %self.x)
        kibaRestart(self.prefix, self.homedir)
        os.system("gconftool-2 --recursive-unset "+self.key)
        self.statusbar.push(8, "Launcher successfully removed")
        for i in self.listMain :
            self.combobox1.remove_text(0)
        for i in self.listMain :
            self.combobox1.append_text(i)
        self.combobox1.set_active(-1)
        self.clean()
        self.spinbutton1.set_value(0)
    #-- Window1.on_buttonDel_clicked }

    #-- Window1.on_buttonAdd_clicked {
    #-- Window1.on_buttonAdd_clicked }

    #-- Window1.on_buttonIcon_clicked {
    #----------------------------------------------
    def on_buttonIcon_clicked(self, widget, *args):
    #----------------------------------------------
        """ When "browse icon" button is pressed """
        # Select an icon for the launcher 
        if self.entry2.get_text() != "":
            self.icondir = os.path.abspath(self.entry2.get_text())
        self.vari = openIconDialog(self.homedir)
        if self.vari == "":
            return
        # Write output into entry 4
        self.entry5.set_text(self.vari)
        # Display icon
        self.image6.set_from_file(self.vari)
        self.statusbar.push(6, "Icon selected : %s" %self.vari)
    #-- Window1.on_buttonIcon_clicked }

    #-- Window1.on_buttonSave_clicked {
    #----------------------------------------------
    def on_buttonSave_clicked(self, widget, *args):
    #----------------------------------------------
        """ When "save entries" button is pressed """
        self.icon = self.entry5.get_text()
        self.ext = os.path.splitext(self.icon)[1]
        self.name = self.entry3.get_text()
        self.cmd = self.entry4.get_text()
        if self.namelow == "":
            self.namelow = self.name.lower().replace(" ","")
        self.fileName = self.namelow + ".desktop"
        if self.entry2.get_text() != "" and os.path.isabs(self.icon):
            self.icondir = os.path.abspath(self.entry2.get_text())
            os.system("cp %s %s/%s%s" %(self.icon, self.icondir, self.namelow, self.ext))
            self.icon = "%s/%s%s" %(self.icondir, self.namelow, self.ext)
        if not (self.namelow in self.listPos):
            self.listPos.insert(int(self.spinbutton1.get_value() -1), self.namelow)
        else :
            self.listPos.remove(self.namelow)
            self.listPos.insert(int(self.spinbutton1.get_value()) -1, self.namelow)
        if (self.name == "") or (self.cmd == "") or (self.icon == "") or (self.fileName == ""): 
                self.statusbar.push(5, "Please fill in all entries !")
                return
        if self.newItem :
            print "new file"
            print self.dire + "/" +self.fileName
			# Filing the .desktop file
            self.ecriture = open(self.dire + "/" +self.fileName, "w") 
            self.ecriture.write("[Desktop Entry]\n")
            self.ecriture.write("Version=1.0\n")
            self.ecriture.write("Encoding=UTF-8\n")
            self.ecriture.write("Name=%s\n" %(self.name))
            self.ecriture.write("Comment=none\n")
            self.ecriture.write("Exec=%s\n" %(self.cmd))
            self.ecriture.write("Icon=%s\n" %(self.icon))
            self.ecriture.write("Terminal=false\n")
            self.ecriture.write("Type=Application\n")
            self.ecriture.write("Categories=Application;\n")
            self.ecriture.close()
            key = "/apps/kiba/launchers/%s/file" %self.namelow
            file = self.dire + "/" + self.namelow + ".desktop"
            #print file
            os.system("gconftool-2 --set %s --type string %s" %(key, file))
            os.system("gconftool-2 --apply-schema /schemas/apps/kiba/launchers/file %s" %key)
            self.gconfdir = "/apps/kiba/launchers/%s" %self.namelow
            self.client.set_int(self.gconfdir +"/position", int(self.spinbutton1.get_value()))
            # Add launcher into combobox
            self.combobox1.append_text(self.fileName)
            self.listMain.append(self.fileName)
        else :
			# Modifying an existing .desktop file
            self.client.set_string(self.gconfdir + "/name", self.name)
            self.client.set_string(self.gconfdir + "/exec", self.cmd)
            self.client.set_string(self.gconfdir + "/icon", self.icon)
            self.client.set_int(self.gconfdir +"/position", int(self.spinbutton1.get_value()))
    #-- Window1.on_buttonSave_clicked }


#----------------------------
#       MAIN PROGRAM
#----------------------------

#-- main {
if os.path.exists("/usr/share/kiba-dock/kiba-icons.glade") :
    gladePath = "/usr/share/kiba-dock/kiba-icons.glade"
else :
    gladePath = "kiba-icons.glade"

def main():
    gnome.program_init("kiba-icon-editor", "0.0.999")
    window1 = Window1(path=gladePath)

    window1.run()

if __name__ == "__main__":

    main()

#-- main }
