#!/usr/bin/env python
# -*- coding: UTF8 -*-

import os, time
import pygtk
pygtk.require('2.0')

import gtk, gobject, sys, gconf
import egg.trayicon
from datetime import date

#---------------------------
def start_kiba(force=False):
#---------------------------
	""" Start or restart kiba-dock """
	sortie = os.popen("ps -C kiba-dock | grep kiba-dock").read().rstrip()
	if force == True :
		os.system("killall kiba-dock &")
		sortie = ""
	if sortie == "" :
		if os.path.exists("/usr/bin/kiba-dock"):
			os.system("kiba-dock &")
		else :
			os.system("exec %s/kiba-dock &" %pythonPath)

#--------------------
def place_menu(menu):
#--------------------
	(width, height) = menu.size_request()
	(menu_xpos, menu_ypos) = tray.window.get_origin()
	menu_xpos = menu_xpos + tray.allocation.x
        menu_ypos = menu_ypos + tray.allocation.y
	if menu_ypos > tray.get_screen().get_height() / 2:
                menu_ypos -= height + 1
        else:
                menu_ypos += tray.allocation.height + 1

        x = menu_xpos;
        y = menu_ypos;
        push_in = True;
	return (x, y, push_in)

#--------------------------------
def switchState(command, widget):
#--------------------------------
	etat = client.get_bool('/apps/kiba/options/%s' %command) 
	widget.set_active(etat)
	#print command
	#print widget.get_active()

#-----------------------------------
def configure_menu_activate(widget):
#-----------------------------------
	""" Launch gcond-editor """
	os.system("gconf-editor /apps/kiba/options &")

#-------------------------
def gset_activate(widget):
#-------------------------
	""" Launch gset-kiba """
	if os.path.isfile("/usr/bin/gset-kiba") :
		os.system("gset-kiba &")
	else :
		os.system("exec %s/gset-kiba &" %pythonPath)

#----------------------------------------------
def generic_on_off(option, param="", wid=None):
#----------------------------------------------
	""" Switch an option state """
	global client
	if param == "" :
		etat = client.get_bool('/apps/kiba/options/%s' %option)
	else :
		etat = param
	if etat :
		client.set_bool('/apps/kiba/options/%s' %option, False)
		print "%s off" %option
		if wid != None :
			wid.set_active(False)
	else :
		client.set_bool('/apps/kiba/options/%s' %option, True)
		print "%s on" %option
		if wid != None :
			wid.set_active(True)

#-----------------------------------
def manage_desktop_activate(widget):
#-----------------------------------
	""" Launch kiba-icon-editor """
	if os.path.exists("/usr/bin/kiba-icon-editor.py"):
		os.system("kiba-icon-editor.py &")
	else :
		print "exception"
		os.system("exec %s/kiba-icon-editor.py &" %pythonPath)

#------------------------------------
def toggle_autohide_activate(widget):
#------------------------------------
	generic_on_off("auto_hide/auto_hide", "", widget)

#--------------------------------
def toggle_text_activate(widget):
#--------------------------------
	generic_on_off("text/text_enable", "", widget)

#---------------------------
def toggle_bouncing(widget):
#---------------------------
	generic_on_off("mouseover_effects/mouseover_bouncing", "", widget)

#---------------------------
def toggle_rotate(widget):
#---------------------------
	generic_on_off("mouseover_effects/exec_rotate", "", widget)

#-------------------------------
def change_model(widget, model):
#-------------------------------
	client.set_string('/apps/kiba/options/physic/model', model)

#------------------------------------
def change_mouseover(widget, effect):
#------------------------------------
	client.set_string('/apps/kiba/options/mouseover_effects/mouse_over_effect', effect)
	if effect == 'zoom' :
		generic_on_off("mouseover_bouncing", True)

#-------------------------------
def save_settings(widget, data):
#-------------------------------
	""" Save all settings in a file """
	global listProfilName
	profName = os.popen("zenity --entry --text='Enter profile name'").read().rstrip()
	profFile = kibaProfDir + profName + ".txt"
	profListe = get_values("/apps/kiba/options")
	write_file(profListe, profFile, profName)
	if profName in listProfilName :
		print "modifiing item"
	else :
		item = gtk.MenuItem(profName)
		item.connect("activate", load_profile, profFile)
		data.append(item)
		menu.show_all()
		listProfilName.append(profName)

#--------------------
def get_values(path):
#--------------------
	""" Get all settings value """
	global client
	optionsList = ["auto_hide","geometry","mouseover_effects","physic","style","text"]
	liste3 = []
	for i in optionsList :
		liste1 = os.popen("gconftool-2 -a %s/%s" %(path,i)).read().rstrip().split("\n")
		#print liste1
		for j in liste1 :
			liste3.append([i,j])
			#print j
	#print liste3
	a = 0
	liste2 = [""] * len(liste3)
	for i in liste3 :
		l = i[1].lstrip()
		machin = l.split(" = ")
		liste2[a] = []
		liste2[a].append(machin[0])
		liste2[a].append(machin[1])
		type = os.popen("gconftool-2 -T %s/%s/%s" %(path, i[0], machin[0])).read().rstrip()
		liste2[a].append(type)
		liste2[a].append(i[0])
		a += 1
	#print liste2
	return liste2

#-------------------------------------
def write_file(listea, fichier, name):
#-------------------------------------
	""" Write all values in a file """
	profFile2 = file(fichier, 'w')
	#profFile2.write(name + "\n")
	for i in listea :
		profFile2.write(i[0] + ";" + i[1] + ";" + i[2] + ";" + i[3] +"\n")
	profFile2.close()

#------------------------------
def load_profile(widget, data):
#------------------------------
	""" Load all settings from a file and apply them """
	global client, itemOption
	path = "/apps/kiba/options"
	lecture = file(data , 'r')
	liste = []
	a = 0
	for i in lecture :
		b = i.split(";")
		b[3] = b[3][0:-1]
		liste.append(b)
	lecture.close()
	for i in liste :
		#client.set("%s/%s" %(path, i[0]), i[1], i[2])
		if i[2] == "string" :
			client.set_string('%s/%s/%s' %(path, i[3], i[0]), i[1])
		elif i[2] == "float" :
			i[1] = float(i[1])
			client.set_float('%s/%s/%s' %(path, i[3], i[0]), i[1])
		elif i[2] == "int" :
			i[1] = int(i[1]) 
			client.set_int('%s/%s/%s' %(path, i[3], i[0]), i[1])
		elif i[2] == "bool" :
			if i[1] == "false" :
				i[1] = False
			elif i[1] == "true" :
				i[1] = True
			else :
				print "error"
				return
			client.set_bool('%s/%s/%s' %(path, i[3], i[0]), i[1])
	#switchState('autohide', itemOption[0])
	#switchState('text_enable', itemOption[1])
	#switchState('mouseover_bouncing', itemOption[2])

#---------------------------------
def restart_kiba_activate(widget):
#---------------------------------
	""" Restart kiba-dock """
	start_kiba(True)

#------------------------------
def quit_menu_activate(widget):
#------------------------------
	""" quit kiba-systray.py """
	os.system("killall kiba-dock")
	gtk.main_quit()

#------------------------
def callback(widget, ev):
#------------------------
	menu.set_screen(widget.get_screen())
	menu.popup(None, None, place_menu, ev.button, ev.time)

#---------------------------------------
#			 MAIN PROGRAM
#---------------------------------------

pythonPath = os.path.dirname(os.path.abspath(sys.argv[0]))
if os.path.exists("/usr/share/icons/hicolor/24x24/apps/kiba_24.png") :
	pixpath = "/usr/share/icons/hicolor/24x24/apps/kiba_24.png"
	#print pixpath
else :
	pixpath = pythonPath +"/icons/kiba_24.png"
curPath = os.getcwd()
homedir = os.environ['HOME']
kibaDir = "/usr/share/kiba-dock"
client = gconf.client_get_default()
kibaProfDir = os.path.expanduser("~/.kiba-dock/profiles/")
if not os.path.isdir(kibaProfDir):
	os.mkdir(kibaProfDir)
	print "profiles folder not found ... creating ..."

#-------------------
# Create widget menu
#-------------------
menu = gtk.Menu()
# Item pref
item = gtk.ImageMenuItem(stock_id=gtk.STOCK_PREFERENCES)
item.connect("activate", configure_menu_activate)
menu.append(item)
# Item gset-kiba
if os.path.exists("%s/gset-kiba" %pythonPath) or os.path.exists("/usr/bin/gset-kiba"):
	item = gtk.MenuItem("Gset-kiba")
	item.connect("activate", gset_activate)
	menu.append(item)
# Item icon manager
if os.path.exists("%s/kiba-icon-editor.py" %pythonPath) or os.path.exists("/usr/bin/kiba-icon-editor.py"):
	item = gtk.MenuItem("Icon Manager")
	item.connect("activate", manage_desktop_activate)
	menu.append(item)
# Separator
item = gtk.SeparatorMenuItem()
menu.append(item)


# Setting up submenu Settings
menu2 = gtk.MenuItem("Options")
menu3 = gtk.Menu()
menu2.set_submenu(menu3)
menu.append(menu2)
# Item Toggle autohide
itemOption = [""]*4
itemOption[0] = gtk.CheckMenuItem("Autohide", "active")
switchState('auto_hide/auto_hide', itemOption[0])
itemOption[0].connect("activate", toggle_autohide_activate)
menu3.append(itemOption[0])
# Item Toggle text
itemOption[1] = gtk.CheckMenuItem("Text On/Off", "active")
switchState('text/text_enable', itemOption[1])
itemOption[1].connect("activate", toggle_text_activate)
menu3.append(itemOption[1])
# item toggle bouncing
itemOption[2] = gtk.CheckMenuItem("Icon Bouncing")
switchState('mouseover_effects/mouseover_bouncing', itemOption[2])
itemOption[2].connect("activate", toggle_bouncing)
menu3.append(itemOption[2])
# item toggle exec rotate
itemOption[3] = gtk.CheckMenuItem("Exec Rotate")
switchState('mouseover_effects/exec_rotate', itemOption[3])
itemOption[3].connect("activate", toggle_rotate)
menu3.append(itemOption[3])


# Setting up submenu dock model
menu6 = gtk.MenuItem("Dock model")
menu7 = gtk.Menu()
menu6.set_submenu(menu7)
menu3.append(menu6)
## Model
model = ["dock", "rope", "wobbly", "spring_for_all"]
listModel = [""]*len(model)
for i in model :
	inc=0
	i2 = i.title().replace("_", " ")
	listModel[inc] = gtk.MenuItem(i2)
	listModel[inc].connect("activate", change_model, i)
	menu7.append(listModel[inc])
	inc += 1


# Setting up submenu mouseover effect
menu8 = gtk.MenuItem("Mouse-over effect")
menu9 = gtk.Menu()
menu8.set_submenu(menu9)
menu3.append(menu8)
## Mouse over effect
mouseover = ["pulse", "zoom", "none"]
listMouseover = [""]*4
for i in mouseover :
	inc = 0
	i2 =  i.title().replace("_", " ")
	listMouseover[inc] = gtk.MenuItem(i2)
	listMouseover[inc].connect("activate", change_mouseover, i)
	menu9.append(listMouseover[inc])
	inc += 1


# Setting up submenu Profiles
menu4 = gtk.MenuItem("Profiles")
menu5 = gtk.Menu()
menu4.set_submenu(menu5)
menu.append(menu4)
# Item Save
item = gtk.MenuItem("Save current settings")
item.connect("activate", save_settings, menu5)
menu5.append(item)
# Separator
item = gtk.SeparatorMenuItem()
menu5.append(item)

# Profiles
listProfiles = []
listProfilName = []
for i in os.listdir(kibaProfDir):
	profilName = os.path.splitext(i)[0]
	listProfilName.append(profilName)
	item = gtk.MenuItem(profilName)
	profileFile = kibaProfDir + i
	item.connect("activate", load_profile, profileFile)
	listProfiles.append(item)
	menu5.append(item)
# Item Restart kiba
item = gtk.MenuItem("Restart Kiba-dock")
item.connect("activate", restart_kiba_activate)
menu.append(item)
item = gtk.SeparatorMenuItem()
menu.append(item)
# Item quit
item = gtk.ImageMenuItem(stock_id=gtk.STOCK_QUIT)
item.connect("activate", quit_menu_activate)
menu.append(item)
menu.show_all()


# trayicon
tray = egg.trayicon.TrayIcon("TrayIcon")
box = gtk.EventBox()

pixbuf = gtk.gdk.pixbuf_new_from_file(pixpath)
image = gtk.Image()
image.set_from_pixbuf(pixbuf)
box.add(image)
tray.add(box)
tray.show_all()
box.connect("button-press-event", callback)
# check if kiba-systray is already launched
long = len(os.popen('ps aux | grep python | grep systray').read().rstrip().split('\n'))
if long < 3 :
	start_kiba()
	gtk.main()
else :
	print "Kiba systray is allready started"
